/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';

/**
 * @category Instructions
 * @category ApproveCollectionAuthority
 * @category generated
 */
const ApproveCollectionAuthorityStruct = new beet.BeetArgsStruct<{
  instructionDiscriminator: number;
}>([['instructionDiscriminator', beet.u8]], 'ApproveCollectionAuthorityInstructionArgs');
/**
 * Accounts required by the _ApproveCollectionAuthority_ instruction
 *
 * @property [_writable_] collectionAuthorityRecord Collection Authority Record PDA
 * @property [] newCollectionAuthority A Collection Authority
 * @property [**signer**] updateAuthority Update Authority of Collection NFT
 * @property [**signer**] payer Payer
 * @property [] metadata Collection Metadata account
 * @property [] mint Mint of Collection Metadata
 * @category Instructions
 * @category ApproveCollectionAuthority
 * @category generated
 */
export type ApproveCollectionAuthorityInstructionAccounts = {
  collectionAuthorityRecord: web3.PublicKey;
  newCollectionAuthority: web3.PublicKey;
  updateAuthority: web3.PublicKey;
  payer: web3.PublicKey;
  metadata: web3.PublicKey;
  mint: web3.PublicKey;
};

const approveCollectionAuthorityInstructionDiscriminator = 23;

/**
 * Creates a _ApproveCollectionAuthority_ instruction.
 *
 * @param accounts that will be accessed while the instruction is processed
 *
 * @category Instructions
 * @category ApproveCollectionAuthority
 * @category generated
 */
export function createApproveCollectionAuthorityInstruction(
  accounts: ApproveCollectionAuthorityInstructionAccounts,
) {
  const {
    collectionAuthorityRecord,
    newCollectionAuthority,
    updateAuthority,
    payer,
    metadata,
    mint,
  } = accounts;

  const [data] = ApproveCollectionAuthorityStruct.serialize({
    instructionDiscriminator: approveCollectionAuthorityInstructionDiscriminator,
  });
  const keys: web3.AccountMeta[] = [
    {
      pubkey: collectionAuthorityRecord,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: newCollectionAuthority,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: updateAuthority,
      isWritable: false,
      isSigner: true,
    },
    {
      pubkey: payer,
      isWritable: false,
      isSigner: true,
    },
    {
      pubkey: metadata,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: mint,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: web3.SystemProgram.programId,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: web3.SYSVAR_RENT_PUBKEY,
      isWritable: false,
      isSigner: false,
    },
  ];

  const ix = new web3.TransactionInstruction({
    programId: new web3.PublicKey('metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
    keys,
    data,
  });
  return ix;
}
